#include <windows.h>
#include "View.h"
#include "Windows\Frame.h"
#include "resource.h"
#include "Mainfrm.h"

using namespace Windows;

CMainFrame::CMainFrame ()
{
	// Set m_View as view window of frame
	SetView(m_View.GetCWinObject());
}

CMainFrame::~CMainFrame ()
{
}

void CMainFrame::OnInitFrame ()
{
	// Set Title
	::SetWindowText(m_hWnd, TEXT("PM Viewer 2.0"));
}

void CMainFrame::EventLoop ()
{
	m_View.EventLoop();
}

LRESULT CMainFrame::WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case TB_CHECKBUTTON:
		m_ToolBar.CheckButton(wParam);
		return 0;
	// Menu and Toolbar Messages
	case WM_COMMAND:
		{
			int cmd = LOWORD(wParam);
			switch (cmd)
			{
			case ID_FILE_OPEN:
			case ID_CONTROL_ROTATE:
			case ID_CONTROL_ZOOM:
			case ID_CONTROL_PAN:
			case ID_DISPLAY_SHOWAXES:
			case ID_DISPLAY_SHOWTEXT:
			case ID_DISPLAY_LIGHTING:
			case ID_DISPLAY_COLOR:
			case ID_DISPLAY_TEXTURES:
			case ID_DISPLAY_CULLPOLYGONS:
			case ID_DISPLAY_BOUNDINGBOX:
			case ID_ANIMATION_START:
			case ID_ANIMATION_STOP:
			case ID_ANIMATION_FIRST:
			case ID_ANIMATION_PREVIOUS:
			case ID_ANIMATION_NEXT:
			case ID_ANIMATION_LAST:
			case ID_UTILITY_DATAVIEW:
				SendMessage(m_View.GetHWnd(), WM_COMMAND, wParam, lParam);
				return 0;
			} // switch(cmd)
		} // case WM_COMMAND
	case WM_SETFOCUS:
		SetFocus(m_View.GetHWnd());
		return 0;
	} // switch(uMsg)

	// Defaults
	return CFrame::WndProc(hWnd, uMsg, wParam, lParam);
}

void CMainFrame::LoadToolbarData ()
{
	// 	 BUTTON = Standard push button
	//	 SEPARATOR = Separator between buttons
	//	 CHECK = Toggle push button with background changes
	//	 GROUP = Toggle push button within group (no background change)
	//	 CHECKGROUP = Toggle push button within group with background change
	// Define button entries
	BYTE bTbarData[][2] = {
		BUTTON,		ID_FILE_OPEN,
		SEPARATOR,	0,
		CHECKGROUP,	ID_CONTROL_PAN,
		CHECKGROUP,	ID_CONTROL_ROTATE,
		CHECKGROUP,	ID_CONTROL_ZOOM,
		SEPARATOR,	0,
		CHECK,		ID_DISPLAY_SHOWAXES,
		CHECK,		ID_DISPLAY_SHOWTEXT,
		CHECK,		ID_DISPLAY_LIGHTING,
		CHECK,		ID_DISPLAY_COLOR,
		CHECK,		ID_DISPLAY_TEXTURES,
		CHECK,		ID_DISPLAY_CULLPOLYGONS,
		CHECK,		ID_DISPLAY_BOUNDINGBOX,
		SEPARATOR,	0,
		BUTTON,		ID_ANIMATION_START,
		BUTTON,		ID_ANIMATION_STOP,
		BUTTON,		ID_ANIMATION_FIRST,
		BUTTON,		ID_ANIMATION_PREVIOUS,
		BUTTON,		ID_ANIMATION_NEXT,
		BUTTON,		ID_ANIMATION_LAST,
		SEPARATOR,	0,
		BUTTON,		ID_UTILITY_DATAVIEW,
	};

	// Calculate number of entries
	m_ToolbarButtons = sizeof(bTbarData)/(2*sizeof(BYTE));

	m_ToolbarData = new BYTE[m_ToolbarButtons][2];
	for (int x=0; x<m_ToolbarButtons; x++)
	{
		m_ToolbarData[x][0] = bTbarData[x][0];
		m_ToolbarData[x][1] = bTbarData[x][1];
	}
}