#ifndef COLOR_H
#define COLOR_H

#include "common.h"

struct Color {
	u8		r;
	u8		g;
	u8		b;
	u8		a;

	void RGB565_Unpack(u16 c);
	void I4_Unpack(u8 c);
	void I8_Unpack(u8 c);
	void IA4_Unpack(u8 c);
	void IA8_Unpack(u16 c);
	void RGB5A3_Unpack(u16 c);
	void RGB4A3_Unpack(u16 c);
	void RGB5_Unpack(u16 c);
	void RGBA8_Unpack(u16 c0, u16 c1);

	void Blend(Color c0, Color c1, u8 ratio);
	void Set(u8 cr, u8 cg, u8 cb, u8 ca);

	u32 RGBA8_Get();
};

#endif COLOR_H