#include "common.h"

using namespace std;

bool fileExists (const string &filename)
{
	FILE *fh = fopen(filename.c_str(), "rb");
	if (fh != NULL) {
		fclose(fh);
		return true;
	}

	return false;
}

string OpenFileDlg (HWND hWnd)
{
	OPENFILENAME ofn;
	char FileName[MAX_PATH] = "";
	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = "All Files (*.*)\0*.*\0";
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST;

	if (GetOpenFileName(&ofn))
		return FileName;

	return "";
}

u8 getComponent (u32 src, int idx)
{
	int mask = (0xFF << (idx * 8));
	return (u8) ((src & mask) >> (idx * 8));
}

s8 getSComponent (u32 src, int idx)
{
	return (s8) getComponent(src, idx);
}