#ifndef COMMON_H
#define COMMON_H

#include <iostream>
#include <string>
#include <windows.h>

using namespace std;

typedef unsigned char		u8;
typedef unsigned short		u16;
typedef unsigned int		u32;
typedef unsigned __int64	u64;
typedef	signed char			s8;
typedef signed short		s16;
typedef signed int			s32;
typedef signed __int64		s64;
typedef float				f32;
typedef	double				f64;

inline void byteSwapU16 (u16 &s)
{
	u8 v1 = s & 0xFF;
	u8 v2 = s >> 8;
	s = (v1 << 8) | v2;
}

inline void byteSwapU32 (u32 &s)
{
	u8 v1 = s & 0xFF;
	u8 v2 = (s >> 8) & 0xFF;
	u8 v3 = (s >> 16) & 0xFF;
	u8 v4 = (s >> 24) & 0xFF;
	s = (v1 << 24) | (v2 << 16) | (v3 << 8) | v4;
}

inline void byteSwapS16 (s16 &s)
{
	byteSwapU16(*(u16*) &s);
}

inline void byteSwapS32 (s32 &s)
{
	byteSwapU32(*(u32*) &s);
}

inline void byteSwapF32 (f32 &f)
{
	byteSwapU32(*(u32*) &f);
}

inline void toggle (int &v)
{
	(v) ? v = 0 : v = 1;
}

bool fileExists (const string &filename);
string OpenFileDlg (HWND hWnd);
u8 getComponent (u32 src, int idx);
s8 getSComponent (u32 src, int idx);

#endif // COMMON_H