#ifndef PMMODEL_H
#define PMMODEL_H

#include <windows.h>
#include <iostream>
#include <string>
#include <vector>
#include "common.h"

using namespace std;

enum PMBlock
{
	BLOCK2, BLOCK3, BLOCK4, BLOCK5, BLOCK6, BLOCK7, BLOCK8, BLOCK9, 
	BLOCK10, BLOCK11, BLOCK12, BLOCK13, BLOCK14, BLOCK15, BLOCK16, BLOCK17, BLOCK18, 
	BLOCK19, BLOCK20, BLOCK21, BLOCK22, BLOCK23, BLOCK24, BLOCK25, BLOCK26, BLOCK27,
};

enum PMBlock27
{
	BLOCK27_2, BLOCK27_3, BLOCK27_4, BLOCK27_5, BLOCK27_6, BLOCK27_7, BLOCK27_8, BLOCK27_9,
};

struct PMMHeader {
	u32		addrBlock27;
	char	modelFile[64];
	char	textureFile[64];
	char	date[64];
	u32		u0xC4;
	u32		u0xC8;
	u32		u0xCC;
	f32		u0xD0;
	f32		u0xD4;
	f32		u0xD8;
	f32		u0xDC;
	f32		u0xE0;
	f32		u0xE4;
	u32		numBlocks[25];
	u32		blockOffset[25];

	inline string strModelFile () {
		string str;
		return str;
	}
};

struct PMMBlock2 {
	char	name[64];
	s32		idxBlock4;
	s32		numBlock4;
	u32		u0x48;
	u32		u0x4C;
	u32		u0x50;
	u32		u0x54;
	s32		idxBlock18;
	s32		numBlock18;
	s32		endVertex;
	u32		u0x64;
	u32		u0x68;
	u32		u0x6C;
	u32		u0x70;
	u32		u0x74;
	u32		u0x78;
	u32		u0x7C;
	u32		u0x80;
	u32		u0x84;
	u32		u0x88;
	u32		u0x8C;
	u32		u0x90;
	u32		u0x94;
	s32		idxBlock22;
	s32		numBlock22;
	u32		u0xA0;
	u32		u0xA4;
};

struct PMMBlock3 {
	u32		extention;
	u32		vertices;
};

struct PMMBlock4 {
	f32		x;
	f32		y;
	f32		z;
};

struct PMMBlock5 {
	u32		vertex;
};

struct PMMBlock6 {
	f32		nx;
	f32		ny;
	f32		nz;
};

struct PMMBlock7 {
	u32		idxBlock6;
};

struct PMMBlock8 {
	u8		r;
	u8		g;
	u8		b;
	u8		a;
};

struct PMMBlock9 {
	u32		idxBlock8;
};

struct PMMBlock10 {
	u32		vertex;
};

struct PMMBlock18 {
	f32		s;
	f32		t;
};

struct PMMBlock19 {
	f32		u0x00;
	f32		u0x04;
	f32		u0x08;
	f32		u0x0C;
	f32		u0x10;
	f32		u0x14;
};

struct PMMBlock20 {
	s32		idxBlock21;
	u32		u0x04;
};

struct PMMBlock21 {
	u32		u0x00;
	s32		idxTex;
	u32		u0x08;
	char	name[52];
};

struct PMMBlock22 {
	u32		u0x00;
	u32		u0x04;
	u32		u0x08;
	u32		u0x0C;
	s32		idxBlock20;		// one per block
	u32		u0x14;
	u32		u0x18;
	u32		u0x1C;
	u32		u0x20;
	u32		u0x24;
	u32		u0x28;
	u32		u0x2C;
	u32		u0x30;
	u32		u0x34;
	s32		idxBlock3;		// Polygon Index!
	s32		numBlock3;
	s32		idxBlock5;
	s32		idxBlock7;
	s32		idxBlock9;
	s32		idxBlock10;		
	u32		u0x50;
	u32		u0x54;
	u32		u0x58;
	u32		u0x5C;
	u32		u0x60;
	u32		u0x64;
	u32		u0x68;
};

struct PMMBlock23 {
	s8		control;
};

struct PMMBlock24 {
	f32		transform;
};

struct PMMBlock25 {
	char	name[64];
	s32		nextRecord;
	s32		childRecord;
	s32		idxBlock2;
	s32		idxBlock23;
	s32		idxBlock24;
	s32		joint;
};

struct PMMBlock26 {
	char	name[52];
	u32		u0x34;
	u32		u0x38;
	u32		addrBlock27;
};

// Sub_Blocks
struct PMMBlock27_Header {
	u32		size;
	u32		numBlocks[8];
	u32		blockOffset[8];
	f32		u0x44;
	f32		u0x48;
	f32		u0x4C;
	f32		u0x50;
	f32		u0x54;
	f32		u0x58;
};

struct PMMBlock27_2 {
	u32		u0x00;
	u32		u0x04;
	f32		time;
};

struct PMMBlock27_3 {
	f32		time;
	u32		idxBlock4;
	u32		numBlock4;
	u32		idxBlock5;
	u32		numBlock5;
	u32		idxBlock6;
	u32		numBlock6;
	u32		idxBlock7;
	u32		numBlock7;
	u32		idxBlock8;
	u32		numBlock8;
};

struct PMMBlock27_4 {
	u32		u0x00;
};

struct PMMBlock27_5 {
	u32		u0x00;
};

struct PMMBlock27_6 {
	u32		u0x00;
	u32		u0x04;
	u32		u0x08;
};

struct PMMBlock27_7 {
	u8		v1;
	s8		v2;
	u8		v3;
	u8		v4;
};

struct PMMBlock27_8 {
	u32		u0x00;
};

struct PMMBlock27_9 {
	u32		u0x00;
	u32		u0x04;
};

struct PMMBlock27 {
	PMMBlock27_Header		header;
	vector<PMMBlock27_2>	Block2;
	vector<PMMBlock27_3>	Block3;
	vector<PMMBlock27_4>	Block4;
	vector<PMMBlock27_5>	Block5;
	vector<PMMBlock27_6>	Block6;
	vector<PMMBlock27_7>	Block7;
	vector<PMMBlock27_8>	Block8;
	vector<PMMBlock27_9>	Block9;
};

class CPMModel
{
public:
	CPMModel ();
	virtual ~CPMModel ();

	bool LoadFile (const string &filename);

	string		m_filename;
	PMMHeader	m_header;
	vector<PMMBlock2>	m_Block2;
	vector<PMMBlock3>	m_Block3;
	vector<PMMBlock4>	m_Block4;
	vector<PMMBlock5>	m_Block5;
	vector<PMMBlock6>	m_Block6;
	vector<PMMBlock7>	m_Block7;
	vector<PMMBlock8>	m_Block8;
	vector<PMMBlock9>	m_Block9;
	vector<PMMBlock10>	m_Block10;
	vector<PMMBlock18>	m_Block18;
	vector<PMMBlock19>	m_Block19;
	vector<PMMBlock20>	m_Block20;
	vector<PMMBlock21>	m_Block21;
	vector<PMMBlock22>	m_Block22;
	vector<PMMBlock23>	m_Block23;
	vector<PMMBlock24>	m_Block24;
	vector<PMMBlock25>	m_Block25;
	vector<PMMBlock26>	m_Block26;
	vector<PMMBlock27>	m_Block27;

protected:
	void		ReadHeader (FILE* fh);
	void		ReadBlock2 (FILE* fh);
	void		ReadBlock3 (FILE* fh);
	void		ReadBlock4 (FILE* fh);
	void		ReadBlock5 (FILE* fh);
	void		ReadBlock6 (FILE* fh);
	void		ReadBlock7 (FILE* fh);
	void		ReadBlock8 (FILE* fh);
	void		ReadBlock9 (FILE* fh);
	void		ReadBlock10 (FILE* fh);
	void		ReadBlock18 (FILE* fh);
	void		ReadBlock19 (FILE* fh);
	void		ReadBlock20 (FILE* fh);
	void		ReadBlock21 (FILE* fh);
	void		ReadBlock22 (FILE* fh);
	void		ReadBlock23 (FILE* fh);
	void		ReadBlock24 (FILE* fh);
	void		ReadBlock25 (FILE* fh);
	void		ReadBlock26 (FILE* fh);
	
	void		ReadBlock27 (FILE* fh);
	void		ReadBlock27_1 (FILE* fh, int idx);
	void		ReadBlock27_2 (FILE* fh, int idx);
	void		ReadBlock27_3 (FILE* fh, int idx);
	void		ReadBlock27_4 (FILE* fh, int idx);
	void		ReadBlock27_5 (FILE* fh, int idx);
	void		ReadBlock27_6 (FILE* fh, int idx);
	void		ReadBlock27_7 (FILE* fh, int idx);
	void		ReadBlock27_8 (FILE* fh, int idx);
	void		ReadBlock27_9 (FILE* fh, int idx);
};

#endif // PMMODEL_H