#ifndef PMMODELGL_H
#define PMMODELGL_H

#include <vector>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include "pmmodel.h"
#include "common.h"
#include "tpl.h"

using namespace std;

class CPMModelGL : public CPMModel
{
public:
	CPMModelGL ();
	virtual ~CPMModelGL ();

	bool LoadFile(const string &filename);
	void TransformNode (s32 idxB25);
	void DrawNode (s32 idxB25);
	void DrawBox (f32 p0x, f32 p0y, f32 p0z, f32 p1x, f32 p1y, f32 p1z);
	void DrawBoundingBox ();

	void showTextures (u32 set);

	TPL		m_tpl;

private:
	bool LoadTextures();

	vector<GLuint> m_gltex;
	GLuint	m_blank;
	u32		m_showTex;
};

#endif // PMMODELGL_H