#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include <iostream>
#include <string>
#include <vector>
#include "common.h"
#include "pmworld.h"

using namespace std;

CPMWorld::CPMWorld ()
{
}

CPMWorld::~CPMWorld ()
{
}

bool CPMWorld::LoadFile (const string &filename)
{
	m_filename = filename;
	
	FILE* fh;
	fh = fopen(m_filename.c_str(), "rb");
	if (fh == NULL)
		return false;

	fseek(fh, 0, SEEK_END);
	u32 flen = ftell(fh);

	m_data.resize(flen/sizeof(f32));

	fseek(fh, 0, SEEK_SET);
	fread(&m_data, sizeof(f32), flen/sizeof(f32), fh);

	fclose(fh);

	return true;
}

void CPMWorld::DrawWorld ()
{
	glColor3f(1.0f, 1.0f, 1.0f);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_CULL_FACE);

	glBegin(GL_POINTS);
	for (u32 x=(0x71fc8/4); x<m_data.size(); x+=3)
		glVertex3f(m_data[x], m_data[x+1], m_data[x+2]);
	glEnd();
}