#include <windows.h>
#include <string>
#include "Windows\Dialog.h"
#include "pmmodelgl.h"
#include "viewdialog.h"
#include "resource.h"

using namespace Windows;
using namespace std;

CPMDataDialog::CPMDataDialog (UINT nResID, HWND hWndParent)
	: CDialog(nResID, hWndParent)
{	
}

CPMDataDialog::CPMDataDialog (UINT nResID, CPMModelGL* pmm, HWND hWndParent)
	: CDialog(nResID, hWndParent)
{	
	m_pmm = pmm;
}

CPMDataDialog::CPMDataDialog (LPCTSTR lpszResName, HWND hWndParent)
	: CDialog(lpszResName, hWndParent)
{
}

CPMDataDialog::CPMDataDialog (LPCDLGTEMPLATE lpTemplate, HWND hWndParent)
	: CDialog(lpTemplate, hWndParent)
{
}

CPMDataDialog::~CPMDataDialog ()
{
}

BOOL CPMDataDialog::DialogProc (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			m_hWnd = hwnd;
			//Center the dialog
			POINT CenterPt = Center(m_hWnd);
			::SetWindowPos(m_hWnd, HWND_TOP, CenterPt.x, CenterPt.y, 0, 0,  SWP_NOSIZE);
		}
		return OnInitDialog();
	case WM_COMMAND:
		// Notifications
		switch (HIWORD(wParam))
		{
		case CBN_SELCHANGE:
			{
				LRESULT r27 = SendDlgItemMessage(m_hWnd, IDC_COMBO2, CB_GETCURSEL, 0, 0);
				LRESULT res = SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_GETCURSEL, 0, 0);

				if (LOWORD(wParam) == IDC_COMBO1 || LOWORD(wParam) == IDC_COMBO2)
					switch (res)
					{
					case 0: SetHeader(); break;
					case 1: SetBlock2(); break;
					case 2: SetBlock3(); break;
					case 3: SetBlock4(); break;
					case 4: SetBlock5(); break;
					case 5: SetBlock6(); break;
					case 6: SetBlock8(); break;
					case 7: SetBlock10(); break;
					case 8: SetBlock19(); break;
					case 9: SetBlock20(); break;
					case 10: SetBlock21(); break;
					case 11: SetBlock22(); break;
					case 12: SetBlock23(); break;
					case 13: SetBlock24(); break;
					case 14: SetBlock25(); break;
					case 15: SetBlock26(); break;
					case 16: SetBlock27(r27); break;
					}
				return TRUE;
			}
		}
		// Messages
		switch (LOWORD(wParam))
		{
		case IDOK:
			OnOK();
			return TRUE;
		case IDCANCEL:
			OnCancel();
			return TRUE;
	//	case CB_GETCURSEL:

		}
		
	}

	return FALSE;
}

BOOL CPMDataDialog::OnInitDialog ()
{
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, WM_SETFONT, 
		(WPARAM)GetStockObject(ANSI_FIXED_FONT), TRUE);
	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETFONT, 
		(WPARAM)GetStockObject(ANSI_FIXED_FONT), TRUE);

	InitLists();
	return true;
}

void CPMDataDialog::InitLists ()
{
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Header");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 2");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 3");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 4");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 5");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 6");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 8");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 10");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 19");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 20");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 21");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 22");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 23");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 24");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 25");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 26");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) "Block 27");
	SendDlgItemMessage(m_hWnd, IDC_COMBO1, WM_SETTEXT, 0, (LPARAM) "Header");
	SetHeader();

	for (int x=0; x<m_pmm->m_Block26.size(); x++)
		SendDlgItemMessage(m_hWnd, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM) m_pmm->m_Block26[x].name);
	SendDlgItemMessage(m_hWnd, IDC_COMBO2, CB_SETCURSEL, 0, 0);
}

void CPMDataDialog::SetHeader ()
{
	string str;
	str += "Header:\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	char buffer[400];
	sprintf(buffer, "Model:\t\t%-64s\r\nTexture:\t%-64s\r\nDate:\t\t%-64s\r\nUnknowns:\t%4i\r\n\t\t%4i\r\n\t\t%4i\r\n\r\nBounding Box Coordinates:\r\n\t(%7.3f, %7.3f, %7.3f)\r\n\t(%7.3f, %7.3f, %7.3f)", 
		m_pmm->m_header.modelFile, m_pmm->m_header.textureFile, m_pmm->m_header.date,
		m_pmm->m_header.u0xC4, m_pmm->m_header.u0xC8, m_pmm->m_header.u0xCC,
		m_pmm->m_header.u0xD0, m_pmm->m_header.u0xD4, m_pmm->m_header.u0xD8,
		m_pmm->m_header.u0xDC, m_pmm->m_header.u0xE0, m_pmm->m_header.u0xE4);

	str.append(buffer);
	
	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock2 ()
{
	string str;
	str += "Block 2: Scenegraph Components\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block2.size(); x++)
	{
		char buffer[300];
		sprintf(buffer, "%3i: %-32s\r\n    %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i\r\n    %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i\r\n    %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i\r\n\r\n",
			x, m_pmm->m_Block2[x].name, m_pmm->m_Block2[x].idxBlock4, m_pmm->m_Block2[x].numBlock4,
			m_pmm->m_Block2[x].u0x48, m_pmm->m_Block2[x].u0x4C, m_pmm->m_Block2[x].u0x50,
			m_pmm->m_Block2[x].u0x54, m_pmm->m_Block2[x].idxBlock18, m_pmm->m_Block2[x].numBlock18,
			m_pmm->m_Block2[x].endVertex, m_pmm->m_Block2[x].u0x64, m_pmm->m_Block2[x].u0x68,
			m_pmm->m_Block2[x].u0x6C, m_pmm->m_Block2[x].u0x70, m_pmm->m_Block2[x].u0x74,
			m_pmm->m_Block2[x].u0x78, m_pmm->m_Block2[x].u0x7C, m_pmm->m_Block2[x].u0x80,
			m_pmm->m_Block2[x].u0x84, m_pmm->m_Block2[x].u0x88, m_pmm->m_Block2[x].u0x8C,
			m_pmm->m_Block2[x].u0x90, m_pmm->m_Block2[x].u0x94, m_pmm->m_Block2[x].idxBlock22,
			m_pmm->m_Block2[x].numBlock22, m_pmm->m_Block2[x].u0xA0,m_pmm->m_Block2[x].u0xA4);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock3 ()
{
	string str;
	str += "Block 3: Polygons\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block3.size(); x++)
	{
		char buffer[100];
		sprintf(buffer, "%3i: %4i, %4i\r\n",
			x, m_pmm->m_Block3[x].extention, m_pmm->m_Block3[x].vertices);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock4 ()
{
	string str;
	str += "Block 4: Vertices\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block4.size(); x++)
	{
		char buffer[100];
		sprintf(buffer, "%3i: % 7.3f, % 7.3f, % 7.3f\r\n", x,
			m_pmm->m_Block4[x].x, m_pmm->m_Block4[x].y, m_pmm->m_Block4[x].z);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock5 ()
{
	string str;
	str += "Block 5: Vertex Order\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block5.size(); x++)
	{
		char buffer[50];
		sprintf(buffer, "%3i: %4i\r\n", x,
			m_pmm->m_Block5[x].vertex);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock6 ()
{
	string str;
	str += "Block 6: Normals\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block6.size(); x++)
	{
		char buffer[100];
		sprintf(buffer, "%3i: % 7.3f, % 7.3f, % 7.3f\r\n", x,
			m_pmm->m_Block6[x].nx, m_pmm->m_Block6[x].ny, m_pmm->m_Block6[x].nz);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock8 ()
{
	string str;
	str += "Block 8: Color\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block8.size(); x++)
	{
		char buffer[100];
		sprintf(buffer, "%3i: (%3i,%3i,%3i,%3i)\r\n", x,
			m_pmm->m_Block8[x].r, m_pmm->m_Block8[x].g, m_pmm->m_Block8[x].b,
			m_pmm->m_Block8[x].a);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock10 ()
{
	string str;
	str += "Block 10: Texture Vertex Order\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block10.size(); x++)
	{
		char buffer[100];
		sprintf(buffer, "%3i: %4i\r\n", x,
			m_pmm->m_Block10[x].vertex);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock19 ()
{
	string str;
	str += "Block 19: Unknown\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block19.size(); x++)
	{
		char buffer[150];
		sprintf(buffer, "%3i: % 7.3f, % 7.3f, % 7.3f, % 7.3f, % 7.3f, % 7.3f\r\n", x,
			m_pmm->m_Block19[x].u0x00, m_pmm->m_Block19[x].u0x04, m_pmm->m_Block19[x].u0x08,
			m_pmm->m_Block19[x].u0x0C, m_pmm->m_Block19[x].u0x10, m_pmm->m_Block19[x].u0x14);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock20 ()
{
	string str;
	str += "Block 20: Texture Map\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block20.size(); x++)
	{
		char buffer[100];
		sprintf(buffer, "%3i: %4i, %4i\r\n", x,
			m_pmm->m_Block20[x].idxBlock21, m_pmm->m_Block20[x].u0x04);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock21 ()
{
	string str;
	str += "Block 21: Texture Definition\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block21.size(); x++)
	{
		char buffer[200];
		sprintf(buffer, "%3i: %4i, %4i, %4i, %-32s\r\n\tFormat: %4i\tWrap_S: %4i\tWrap_T: %4i\r\n\r\n", x,
			m_pmm->m_Block21[x].u0x00, m_pmm->m_Block21[x].idxTex, m_pmm->m_Block21[x].u0x08,
			m_pmm->m_Block21[x].name, 
			m_pmm->m_tpl.m_tex[m_pmm->m_Block21[x].idxTex].texHeader->format,
			m_pmm->m_tpl.m_tex[m_pmm->m_Block21[x].idxTex].texHeader->wrap_s,
			m_pmm->m_tpl.m_tex[m_pmm->m_Block21[x].idxTex].texHeader->wrap_t);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock22 ()
{
	string str;
	str += "Block 22: Polygon Set\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block22.size(); x++)
	{
		char buffer[400];
		sprintf(buffer, "%3i: %4i, %4i, %4i, %4i, %4i, \r\n     %4i, %4i, %4i, %4i, %4i, %4i, %4i, %08X, %4i, \r\n     %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i, %4i\r\n\r\n", x,
			m_pmm->m_Block22[x].u0x00, m_pmm->m_Block22[x].u0x04, m_pmm->m_Block22[x].u0x08,
			m_pmm->m_Block22[x].u0x0C, m_pmm->m_Block22[x].idxBlock20, m_pmm->m_Block22[x].u0x14,
			m_pmm->m_Block22[x].u0x18, m_pmm->m_Block22[x].u0x1C, m_pmm->m_Block22[x].u0x20,
			m_pmm->m_Block22[x].u0x24, m_pmm->m_Block22[x].u0x28, m_pmm->m_Block22[x].u0x2C,
			m_pmm->m_Block22[x].u0x30, m_pmm->m_Block22[x].u0x34, m_pmm->m_Block22[x].idxBlock3,
			m_pmm->m_Block22[x].numBlock3, m_pmm->m_Block22[x].idxBlock5, m_pmm->m_Block22[x].idxBlock7,
			m_pmm->m_Block22[x].idxBlock9, m_pmm->m_Block22[x].idxBlock10, m_pmm->m_Block22[x].u0x50,
			m_pmm->m_Block22[x].u0x54, m_pmm->m_Block22[x].u0x58, m_pmm->m_Block22[x].u0x5C,
			m_pmm->m_Block22[x].u0x60, m_pmm->m_Block22[x].u0x64, m_pmm->m_Block22[x].u0x68);
		str.append(buffer);
		str += "------------------------------------------------------------\r\n\r\n";
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock23 ()
{
	string str;
	str += "Block 23: Scenegraph Component Visibility\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block23.size(); x++)
	{
		char buffer[50];
		sprintf(buffer, "%3i: %4i\r\n", x,
			m_pmm->m_Block23[x].control);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock24 ()
{
	string str;
	str += "Block 24: Model Transformations\r\n";
	str += "------------------------------------------------------------\r\n\r\n";
	str.append("           1        2        3        4        5        6        7        8        9       10       11       12       13       14       15       16       17       18       19       20       21       22       23       24");

	for (int x=0; x<m_pmm->m_Block24.size(); x++)
	{
		char buffer[50];
		if (x % 24 == 0)
			sprintf(buffer, "\r\n%3i: % 7.3f", x, m_pmm->m_Block24[x].transform);
		else
			sprintf(buffer, ", % 7.3f", m_pmm->m_Block24[x].transform);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock25 ()
{
	string str;
	str += "Block 25: Scenegraph\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block25.size(); x++)
	{
		char buffer[200];
		sprintf(buffer, "%3i: %-16s, %4i, %4i, %4i, %4i, %4i, %4i\r\n", x,
			m_pmm->m_Block25[x].name, m_pmm->m_Block25[x].nextRecord, m_pmm->m_Block25[x].childRecord,
			m_pmm->m_Block25[x].idxBlock2, m_pmm->m_Block25[x].idxBlock23, m_pmm->m_Block25[x].idxBlock24,
			m_pmm->m_Block25[x].joint);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock26 ()
{
	string str;
	str += "Block 26: Animation Set Index\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block26.size(); x++)
	{
		char buffer[100];
		sprintf(buffer, "%3i: %-16s, %4i, %4i, %08X\r\n", x,
			m_pmm->m_Block26[x].name, m_pmm->m_Block26[x].u0x34,
			m_pmm->m_Block26[x].u0x38, m_pmm->m_Block26[x].addrBlock27);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}

void CPMDataDialog::SetBlock27 (int idx)
{
	string str;
	str += "Block 27: Animation Data\r\n";
	str += "Set: ";
	str.append(m_pmm->m_Block26[idx].name);
	str += "\r\n";
	str += "------------------------------------------------------------\r\n\r\n";
	
	// Header
	str += "Header\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	char buffer[200];
	sprintf(buffer, "Coordinates:\r\n\t(%7.3f, %7.3f, %7.3f)\r\n\t(%7.3f, %7.3f, %7.3f)\r\n", 
		m_pmm->m_Block27[idx].header.u0x44, m_pmm->m_Block27[idx].header.u0x48,
		m_pmm->m_Block27[idx].header.u0x4C, m_pmm->m_Block27[idx].header.u0x50,
		m_pmm->m_Block27[idx].header.u0x54, m_pmm->m_Block27[idx].header.u0x58);
	str.append(buffer);

	// Block 2
	str += "\r\nSet Info\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block27[idx].Block2.size(); x++)
	{
		sprintf(buffer, "%3i:\tLoop:\t%4i\r\n\tUnknown:%4i\r\n\tTime:\t%7.3f\r\n", x,
			m_pmm->m_Block27[idx].Block2[x].u0x00, m_pmm->m_Block27[idx].Block2[x].u0x04,
			m_pmm->m_Block27[idx].Block2[x].time);
		str.append(buffer);
	}

	// Block 3
	str += "\r\nFrame List\r\n";
	str += "------------------------------------------------------------\r\n\r\n";
	str += "              4________  5________  6________  7________  8________\r\n";

	for (int x=0; x<m_pmm->m_Block27[idx].Block3.size(); x++)
	{
		sprintf(buffer, "%3i: %7.3f, %4i,%4i, %4i,%4i, %4i,%4i, %4i,%4i, %4i,%4i\r\n", x,
			m_pmm->m_Block27[idx].Block3[x].time, m_pmm->m_Block27[idx].Block3[x].idxBlock4,
			m_pmm->m_Block27[idx].Block3[x].numBlock4, m_pmm->m_Block27[idx].Block3[x].idxBlock5,
			m_pmm->m_Block27[idx].Block3[x].numBlock5, m_pmm->m_Block27[idx].Block3[x].idxBlock6,
			m_pmm->m_Block27[idx].Block3[x].numBlock6, m_pmm->m_Block27[idx].Block3[x].idxBlock7,
			m_pmm->m_Block27[idx].Block3[x].numBlock7, m_pmm->m_Block27[idx].Block3[x].idxBlock8,
			m_pmm->m_Block27[idx].Block3[x].numBlock8);
		str.append(buffer);
	}

	// Block 4
	if (m_pmm->m_Block27[idx].Block4.size() > 0)
	{
		str += "\r\n4: Unknown\r\n";
		str += "------------------------------------------------------------\r\n\r\n";

		for (int x=0; x<m_pmm->m_Block27[idx].Block3.size(); x++)
		{
			int st = m_pmm->m_Block27[idx].Block3[x].idxBlock4;

			for (int y=st; y<st + m_pmm->m_Block27[idx].Block3[x].numBlock4; y++)
			{
				sprintf(buffer, "%3i: %08X (% 4i,% 4i,% 4i,% 4i)\r\n", y,
					m_pmm->m_Block27[idx].Block4[y].u0x00,
					getSComponent(m_pmm->m_Block27[idx].Block4[y].u0x00, 3),
					getSComponent(m_pmm->m_Block27[idx].Block4[y].u0x00, 2),
					getSComponent(m_pmm->m_Block27[idx].Block4[y].u0x00, 1),
					getSComponent(m_pmm->m_Block27[idx].Block4[y].u0x00, 0));
				str.append(buffer);
			}

			str += "----\r\n";
		}
	}

	// Block 5
	if (m_pmm->m_Block27[idx].Block5.size() > 0)
	{
		str += "\r\n5: Unknown\r\n";
		str += "------------------------------------------------------------\r\n\r\n";

		for (int x=0; x<m_pmm->m_Block27[idx].Block3.size(); x++)
		{
			int st = m_pmm->m_Block27[idx].Block3[x].idxBlock5;

			for (int y=st; y<st + m_pmm->m_Block27[idx].Block3[x].numBlock5; y++)
			{
				sprintf(buffer, "%3i: %08X (% 4i,% 4i,% 4i,% 4i)\r\n", y,
					m_pmm->m_Block27[idx].Block5[y].u0x00,
					getSComponent(m_pmm->m_Block27[idx].Block5[y].u0x00, 3),
					getSComponent(m_pmm->m_Block27[idx].Block5[y].u0x00, 2),
					getSComponent(m_pmm->m_Block27[idx].Block5[y].u0x00, 1),
					getSComponent(m_pmm->m_Block27[idx].Block5[y].u0x00, 0));
				str.append(buffer);
			}

			str += "----\r\n";
		}
	}

	// Block 6
	if (m_pmm->m_Block27[idx].Block6.size() > 0)
	{
		str += "\r\n6: Texture Control\r\n";
		str += "------------------------------------------------------------\r\n\r\n";

		for (int x=0; x<m_pmm->m_Block27[idx].Block3.size(); x++)
		{
			int st = m_pmm->m_Block27[idx].Block3[x].idxBlock6;

			for (int y=st; y<st + m_pmm->m_Block27[idx].Block3[x].numBlock6; y++)
			{
				sprintf(buffer, "%3i: %08X, %08X, %08X (% 4i,% 4i,% 4i,% 4i)\r\n", y,
					m_pmm->m_Block27[idx].Block6[y].u0x00,
					m_pmm->m_Block27[idx].Block6[y].u0x04,
					m_pmm->m_Block27[idx].Block6[y].u0x08,
					getSComponent(m_pmm->m_Block27[idx].Block6[y].u0x00, 3),
					getSComponent(m_pmm->m_Block27[idx].Block6[y].u0x00, 2),
					getSComponent(m_pmm->m_Block27[idx].Block6[y].u0x00, 1),
					getSComponent(m_pmm->m_Block27[idx].Block6[y].u0x00, 0));
				str.append(buffer);
			}

			str += "----\r\n";
		}
	}

	// Block 7
	if (m_pmm->m_Block27[idx].Block7.size() > 0)
	{
		str += "\r\n7: Plane Control\r\n";
		str += "------------------------------------------------------------\r\n\r\n";

		for (int x=0; x<m_pmm->m_Block27[idx].Block3.size(); x++)
		{
			int st = m_pmm->m_Block27[idx].Block3[x].idxBlock7;

			for (int y=st; y<st + m_pmm->m_Block27[idx].Block3[x].numBlock7; y++)
			{
				sprintf(buffer, "%3i: %3i, %3i, %3i, %3i\r\n", y,
					m_pmm->m_Block27[idx].Block7[y].v1, m_pmm->m_Block27[idx].Block7[y].v2,
					m_pmm->m_Block27[idx].Block7[y].v3, m_pmm->m_Block27[idx].Block7[y].v4);
				str.append(buffer);
			}

			str += "----\r\n";
		}
	}

	// Block 8
	if (m_pmm->m_Block27[idx].Block8.size() > 0)
	{
		str += "\r\n8: Animation Control?\r\n";
		str += "------------------------------------------------------------\r\n\r\n";

		for (int x=0; x<m_pmm->m_Block27[idx].Block3.size(); x++)
		{
			int st = m_pmm->m_Block27[idx].Block3[x].idxBlock8;

			for (int y=st; y<st + m_pmm->m_Block27[idx].Block3[x].numBlock8; y++)
			{
				sprintf(buffer, "%3i: %08X (% 4i,% 4i,% 4i,% 4i)\r\n", y,
					m_pmm->m_Block27[idx].Block8[y].u0x00,
					getSComponent(m_pmm->m_Block27[idx].Block8[y].u0x00, 3),
					getSComponent(m_pmm->m_Block27[idx].Block8[y].u0x00, 2),
					getSComponent(m_pmm->m_Block27[idx].Block8[y].u0x00, 1),
					getSComponent(m_pmm->m_Block27[idx].Block8[y].u0x00, 0));
				str.append(buffer);
			}

			str += "----\r\n";
		}
	}

	// Block 9
	str += "\r\n9: Unknown\r\n";
	str += "------------------------------------------------------------\r\n\r\n";

	for (int x=0; x<m_pmm->m_Block27[idx].Block9.size(); x++)
	{
		sprintf(buffer, "%3i: %4i, %4i\r\n", x,
			m_pmm->m_Block27[idx].Block9[x].u0x00, m_pmm->m_Block27[idx].Block9[x].u0x04);
		str.append(buffer);
	}

	SendDlgItemMessage(m_hWnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM) str.c_str());
}